                                 
                                                   
                                         
                                               
                                
                                        

              Ŀ
                                                                
                 V I D E O   P A L E T T E   T O O L   V4.15    
                                                                
              

       Programs and Documentation are Copyright 1991 by clySmic Software.
                              All rights reserved.

                                        

     I. INTRODUCTION

     This program allows VGA and MCGA users to:

         View the quarter-million VGA colors available on their systems,

         Set any text-mode attribute (0 - 15) to any color out of the
          quarter-million,

         Control the overscan (a.k.a. border) color (not available on MCGA
          systems),

         Have the colors "stick" with almost all programs,

         Load and save their favorite settings in color files, and

         Use the program in a command-line mode (for batch file use).

     

     II. WHAT'S NEW

     a.   Improved error handling during file processing, especially for
          network use.

     b.   The VPTDIR environment variable, which allows the user to control
          where the .VPT files are loaded and stored.  This is mostly for
          network use.  See section IX, below, for details.

     c.   Can press ScrollLock key to "lock" together all the sliders.

     d.   Now VPT is "reminderware."  Sorry, but its necessary.  The
          easiest workaround is to register the software!  VPT will remind
          you every time in full-screen mode, and 1 out of 20 times in
          command-line mode.

     e.   VPT "remembers" the last file you used and the last attribute you
          were working on (this works only if VPTRES is loaded).

     f.   *Much* faster color loading, due to the use of direct access to
          the DAC registers, rather than going through the BIOS.  The BIOS
          calls are either slow or cause severe flickering.

     g.   Home and End now adjust the color of the slider you're working
          on, use X or Escape to exit.

     h.   A completely new and much better scheme to get the colors to
          stick during a mode change.  This involves a small terminate-and-
          stay-resident program called VPTRES.  MCGA users and those who
          don't want a TSR (its really small) can still use VPT in the old
          manner, without VPTRES.  It is highly recommended though as an
          improved way of controlling colors.  See the TECHNICAL
          INFORMATION section, below, for the gory details.

     i.   During loading you can press F1 for a directory of all the .VPT
          files in the directory that VPT was run from.  You can scroll
          through this list and select a file for loading.

     j.   Networking functions include: network-aware file handling and
          network user "home directory" support.

     

     III. FILES INCLUDED

      VPT.EXE................The Video Palette Tool.
      VPTRES.COM.............Resident portion of the VPT system (optional,
                              but recommended).
      VPT.MAN................Documentation file.
     
      LOCK.COM...............A small TSR that locks EGA and VGA palette
                              registers (use only if needed).  Registered
                              version only.
      SEL.EXE................An ANSI color setting program.  Registered
                              version only.
      VPTLOAD.EXE............VPT color file loader for OS/2 full-screen
                              sessions.  Registered version only.
      TSTPATN.EXE............A television test pattern simulator.
                              Registered version only.
     

     IV. LOADING THE RESIDENT PORTION

     Command: VPTRES

     If you try to load VPTRES more than once, it will print an error
     message and exit.  I recommend you place this command in your
     AUTOEXEC.BAT file.  VPT will run without VPTRES, but VPT runs much
     better with it.  VPTRES is very small and doesn't use any "hot-keys".

     VPTRES has two options: /R which will let you reload VPTRES even
     though its been loaded before.  This is primarily useful for
     environments like Windows 3.0.  The other option is /Q, a "quiet"
     switch that suppresses the program's identification message.

     

     V. USING VPT'S INTERACTIVE MODE

     Command: VPT

     VPT operates in text mode and allows setting of any or all of the
     sixteen attributes available in text mode.  There are three sliders
     (one each for Red, Green, and Blue), each of which can assume any of
     64 values (0 through 63).  The current values are displayed next to
     the sliders on the right side of the screen.

     Key(s)                   Action
             

     Left/Right Arrows        Moves the R,G, or B slider between 0 and 63
                              to control the intensity of the R, G, or B
                              signal.

     Control Left/Right       As above, but moves five positions instead of
                              one.

     Home/End                 Moves slider directly to 0 (Home) or 63
                              (End).

     Up/Down Arrows           Select between the Red, Green, and Blue
                              sliders.

     PageUp/PageDown          Selects an attribute between 0 and 15 to work
                              with.

     A                        About VPT.  Shows licensing and copyright
                              information about VPT.

     B                        Backdrop mode.  This makes the current
                              attribute the background and places text with
                              all sixteen attributes on the screen so you
                              can see the combinations.  Any key exits this
                              mode.

     D                        Loads the Default, boot-up colors.

     L                        Loads the colors from a file of your choice,
                              if no file is specified, STD.VPT is assumed.
                              You don't need to add the .VPT extension.

     O                        Sets the Overscan (border) color to the
                              current attribute.  Not available on MCGA
                              systems.

     S                        Saves the colors to a file of your choice, if
                              no file is specified, STD.VPT is assumed.
                              Note: all .VPT files are saved to the
                              directory VPT was run from, NOT the current
                              directory (unless VPT.EXE is there!).

     T                        Automatically loads the sTandard color file,
                              STD.VPT.  This is the same using Load and
                              typing STD <Enter>; its just easier.

     X or Escape              Exits VPT.

     
     Keys Used While Loading or Saving a File:
     

     F1                       Available during loading only.  Replaces the
                              file with the first entry in a sorted list of
                              .VPT files in the directory VPT was run from.

     Backspace                Erases the last character in the file name.

     Ctrl-Backspace           Erases all the characters in the file name.

     Escape                   Abandon the load or save.

     Enter                    Finishes entry of the filename and performs
                              the operation.

     
     Keys Used While Looking at a Directory with F1
     

     Up/Down Arrows           Scrolls through the directory of .VPT files.

     Home                     Goes to the beginning of the sorted directory
                              list.

     End                      Goes to the end of the sorted directory list.

     Escape                   Abandon the load.

     Enter                    Select the displayed filename and perform the
                              operation.

     

     VI. USING VPT'S COMMAND-LINE MODE

     Command: VPT [option]

     Where [option] is one of the following (capitalization does not
     matter):

     /L [filename]            This loads the specified file, if there is
                              one.  If there isn't, you will get an error
                              message.  If [filename] is not specified,
                              STD.VPT will be assumed.

     /C [filename]            Like /L above, but does an ANSI clear screen
                              afterwards and displays no messages.

     /D                       This loads the default palette.  These are
                              the colors assigned by IBM and are the ones
                              you would see if you didn't use VPT.

     /X                       Only available if VPTRES is not resident,
                              this option resets the "palette load on mode
                              change" option to true (see TECHNICAL
                              INFORMATION, below, for an explanation).

     /H                       Displays color numbers in hexadecimal.

     /I                       Checks for program code file integrity.  If
                              VPT reports that the code file has been
                              corrupted, VPT.EXE has been altered,
                              accidentally or otherwise.  Do not use VPT if
                              this check fails!!  Not foolproof, but better
                              than nothing.

     /?                       Presents a help list recapping your options,
                              indicates whether VPTRES is resident or not,
                              and displays the directory VPT will use to
                              load and save files.

     Any other option will generate an error message.

     The main reason for command-line mode is to include VPT in batch
     files.  First you would run VPT interactively, find the colors you
     like, save them in the STD.VPT file, then include a line like the
     following:

     VPT /L or

     VPT /C

     in your batch file.  This will load your saved colors when you run the
     batch file.  VPT.EXE should be placed in a directory on your PATH.  If
     you don't wish to see the informational messages produced by VPT in
     command-line mode, you can redirect the output to the null device
     (a.k.a. the bit bucket) as follows:

     VPT /L >NUL:

     Note that error messages *cannot* be redirected and will still be
     seen.

     If there are any errors, the DOS ERRORLEVEL is set to 10.

     

     VII. MORE EXAMPLES

     vpt /l mycol             Loads the color file MYCOL.VPT.  This assumes
                              you created such a file using the interactive
                              mode of VPT.

     vpt /c                   Loads STD.VPT and clears the screen.

     vpt /?                   Brings forth help.

     vpt /i                   Runs the integrity check.

     An example batch file:

     @echo off
     rem THIS BATCH FILE RUNS DULLAPP, WHICH, SINCE IT USES ONLY LIGHT
     rem GRAY AND BLACK, IS A GOOD CANDIDATE FOR ADDING COLOR
     
     rem LOAD DULLAPP COLOR SET (DULL.VPT)
     vpt /l dull >nul:
     
     rem RUN THE PROGRAM
     cd \dull
     dullapp
     cd \
     
     rem RE-LOAD STANDARD COLOR SET (STD.VPT) AND CLEAR THE SCREEN
     vpt /c

     

     VIII. OVERRIDING THE DEFAULT DIRECTORY AND NETWORK USAGE

     To override VPT's use of its own directory (the directory it was run
     from) for color file storage, you can define a DOS environment
     variable naming the location you wish to use.  For example, to use the
     C:\FOOBAR\ZUUL directory to load and save your colors files, enter:

     SET VPTDIR=C:\FOOBAR\ZUUL

     at the DOS prompt.  This command can, of course, be placed in a batch
     file.  To see what directory VPT is currently using, type VPT /?.

     Another use of this command is when VPT is run from a network server.
     Let us say that VPT is located on the Z: drive, and each user's home
     directory is defined as drive F:.  In order for the users to share
     VPT's code, but each have their own color files, you would use a set
     statement:

     SET VPTDIR=F:\

     in each user's environment.  This would most likely be done when the
     user logs on.  Now the VPT.EXE file can reside on a drive that the
     user only has permission to read & execute.

     

     IX. TECHNICAL INFORMATION

      GENERAL

     VPT works by manipulating the DAC (digital to analog converter) color
     registers; each register (there are 256, to allow for the 300x200x256
     mode) contains 18 bits, 6 each for Red, Green, and Blue.  Each RGB
     value can go from 0 to 63, all the combinations makes for 262,144
     possible colors.  You can show up to sixteen of these at a time in the
     text modes, each of the sixteen "attributes" can be any color (or all
     the same color) out of the quarter-million.

      VIDEO MODE SETS

     a)   Old method, used by pre-4.xx versions of VPT and still available
          with VPT 4.14 if VPTRES is not resident.

     Normally BIOS resets the EGA and DAC color registers whenever a mode
     set is done.  VPT without VPTRES makes its colors stick across a mode
     set by using the "Default Palette Loading During Mode Set" BIOS call
     to disable this action.  If you desire to return this to its default,
     boot-up condition, use VPT /X.  Then a subsequent mode set, like MODE
     CO80, will cause the default conditions to prevail.

     b)   New, much better, method, used by VPT 4.14 with VPTRES resident.

     VPTRES creates a table and a pointer to VPT's colors that BIOS uses
     whenever a mode set is done.  This ability to override the defaults is
     built into the VGA BIOS.  You don't need to (and can't) use VPT /X
     when using VPTRES.  You also don't need to use VPT /C when exiting
     from graphics programs to "reset" the colors.  All told, a much better
     way to make DAC colors sticky.

      COLOR FILES

     The saved color files have an extension of .VPT which you NEVER need
     to type when using VPT.  For DOS 3.x/4.x users, they are stored in the
     same directory that VPT is run from.  For instance, say VPT is stored
     in the C:\BIN directory, that directory is on your PATH, and you are
     in C:\ZUUL.  When you run VPT, DOS will find it on your PATH in C:\BIN
     and run it.  The color files will also be loaded and stored in C:\BIN.
     For DOS 2.x users, the file will be stored in the root directory
     because DOS 2.x doesn't provide the information to determine where a
     program is run from.

     VPT attempts to check for a valid color file by not loading any files
     that aren't exactly 49 bytes long.  You will get a 'bad color file'
     message.  If a file is 49 bytes long and has a .VPT extension but
     *isn't* a VPT color file, it will get loaded anyway.  The colors
     should be interesting.

      REFERENCES, &c.

     VPT was written based on technical information from the book
     "Programmer's Guide to PC & PS/2 Video Systems" by Richard Wilton and
     IBM's "Display Adapter/2 Technical Reference".  Assembler routines to
     load the DAC registers came from on-line code examples and the "V7VGA
     Technical Reference Manual" by Video-7.

     VPT, TSTPATN, and SEL were written in Turbo Pascal and Assembler.
     VPTRES and LOCK were written entirely in Assembler.

     
     X. CAVEATS

     EGA-aware and VGA-aware programs still will run with their own colors,
     almost all other programs will use the colors VPT sets.

     VPT now uses direct hardware access to the DAC color registers.  VPT
     has been tested on true-blue VGAs and Video-7's FastWrite VGA with
     BIOS version 1.18.

     Note: VPTRES will NOT work on FastWrite VGAs with a BIOS version less
     than 1.18 due to bugs in the Video-7 BIOS.  FastWrite users can still
     use VPT without VPTRES, or can obtain a BIOS upgrade from Video-7.

     

     XI. OTHER INCLUDED PROGRAMS

      LOCK.COM

     If you want to "lock" the colors you set against any EGA/VGA-aware
     programs that try to change them using BIOS: set your colors, then run
     the TSR program LOCK.COM included in this package.  This program can
     be removed and re-run by using a TSR control package like TurboPower's
     excellent MARK and RELEASE (version 2.2 or later).  Note: VPT will not
     be able to reset your colors after LOCK is run.  To reset them, remove
     LOCK, reset, then run LOCK again.  Use LOCK *only* if you need to.

      TSTPATN.EXE

     This is a silly program that displays a test pattern to see what
     various colors look like with lots of text and various lines on the
     screen.  Also great for simulating 1960s TV circa 3 A.M.

      SEL.EXE

     An easy ANSI color selector for those who use ANSI.SYS or a similar
     ANSI screen driver.  Allows easy color selection using one or two-
     letter color mnemonics instead of the ANSI color numbers.  Type SEL /?
     for instructions.

      VPTLOAD.EXE

     This is a program for OS/2 users that will load color files created by
     VPT.  This is just a loader, not a full port of VPT, but combined with
     running VPT in the DOS box, it gives OS/2 users access to all the
     colors in their full-screen sessions.

     

     XII. SHAREWARE/LEGAL/MONEY STUFF (REGISTER NOW!!!)

     VPT is copyright 1991 by clySmic Software (Ralph B Smith Jr,
     President/Chief Programmer).

     VPT is released as Shareware.  If you find this program useful, please
     send clySmic software $25.00 as a registration fee for EACH machine
     (including network copies) it is executed upon.  You will receive by
     mail a non-reminding version of VPT, and the extra accessory programs
     mentioned herein.

     You may copy the program and distribute it without charge for non-
     commercial, non-governmental use.  You may not sell or otherwise
     charge for VPT.  However, users' groups may charge a small fee (not to
     exceed $10) for media and postage.  Commercial and governmental users
     are REQUIRED to pay the user fee.  Please be certain that all files
     are kept together.

     This program is provided AS IS without any warranty, expressed or
     implied, including but not limited to fitness for a particular
     purpose.  So there.

     clySmic Software is not responsible for anything that may happen when
     you use VPT, including hardware damage or information loss.

     PLEASE NOTE THE NEW PO BOX NUMBER!!!

     MAKE CHECKS PAYABLE TO RALPH B SMITH JR - ALL CHECKS MADE OUT TO
     CLYSMIC SOFTWARE WILL BE RETURNED!!!

                                        

                                Ralph B Smith Jr
                                clySmic Software
                                 P. O. Box 2421
                               Empire State Plaza
                                Albany, NY 12220

                              CompuServe 76156,164
